/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred."
 *
 */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)libc-port:gen/opendir.c	1.4"
/*
	opendir -- C library extension routine

*/

#include	<sys/types.h>
#include	<dirent.h>
#include	<sys/stat.h>
#include	<fcntl.h>
#include	<sys/errno.h>

extern char	*malloc();
extern int	open(), close(), stat();
extern int	errno;

#define NULL	0

DIR *
opendir(filename)
	char	*filename;		/* name of directory */
{
	register DIR	*dirp;		/* -> malloc'ed storage */
	register int	fd;		/* file descriptor for read */
	struct stat	sbuf;		/* result of stat() */

	if (stat(filename, &sbuf) == -1) {
		return NULL;
	}
	if ((sbuf.st_mode & S_IFMT) != S_IFDIR) {
		errno = ENOTDIR;
		return NULL;
	}
	if ((fd = open(filename, 0)) == -1) {
		return NULL;
	}
	if (fcntl(fd, F_SETFD, FD_CLOEXEC) == -1) {
		(void)close(fd);
		return NULL;
	}
	if (((dirp = (DIR *)malloc(sizeof(DIR))) == NULL)
	  || ((dirp->dd_buf = (char *)malloc(DIRBUF)) == NULL))	{
		(void)close(fd);
		return NULL;			/* bad luck today */
	}

	dirp->dd_fd = fd;
	dirp->dd_loc = dirp->dd_size = 0;	/* refill needed */

	return dirp;
}
